class Schlange {

  int laenge; //Länge der Schlange
  color farbe; //Hauptfarbe der Schlange
  float alpha, delta;

  //"farben" speichert die Farben der Segmente der Schlange
  color[] farben;
  //xWerte speichert die Segmente der Schlange
  //yWerte entsprechend die y-Positionen
  int[] xWerte, yWerte; 

  //--------------------------------------------------

  Schlange(int x, int y, int plaenge) {
    laenge = plaenge; 
    farben = new int[laenge];
    xWerte = new int[laenge]; 
    yWerte = new int[laenge]; 

    farbe = color(random(0, 360), 255, 255);
    alpha = random(TWO_PI); 
    delta = random(7, 9);

    for (int i = 0; i < laenge; i ++ ) {
      xWerte[i] = x; 
      yWerte[i] = y;
      farben[i] = color(hue(farbe), 255, random(127, 255));
    }
  }

  //--------------------------------------------------
  //berechnet für jedes Schlangenobjekt die nächsten 
  //Kreise und Farben, die die Schlange erzeugen. 
  //--------------------------------------------------

  void update() {
    for (int i = 0; i < xWerte.length-1; i ++ ) {     
      xWerte[i] = xWerte[i+1];
      yWerte[i] = yWerte[i+1];   
      farben[i] = farben[i+1];
    } 
    // Neuer Ort und neue Farbe hinten anfügen
    xWerte[xWerte.length-1] = xWerte[xWerte.length-1]+(int)(0.6*delta*cos(alpha)) ;
    yWerte[yWerte.length-1] = yWerte[yWerte.length-1]+(int)(0.6*delta*sin(alpha)) ;   
    farben[farben.length-1] = color(hue(farbe), 255, random(127, 255));

    alpha = alpha + random(-0.2, 0.2);
    delta = delta + random(0.01); 

    //Am Rand umdrehen
    if ( xWerte[xWerte.length-1] <20) alpha = random(-0.3, 0.3);
    if ( yWerte[yWerte.length-1] >height-20) alpha =random(-PI/2-0.3, -PI/2+0.3);
    if ( xWerte[xWerte.length-1] >width-20) alpha =random(PI-0.3, PI+0.3);
    if ( yWerte[yWerte.length-1] < 20) alpha =random(-3*PI/2-0.3, -3*PI/2+0.3);
  }

  //--------------------------------------------------
  // malt die Schlange an der aktuellen Stelle
  //--------------------------------------------------

  void display() {
    for (int i = 0; i < xWerte.length; i ++ ) {
      noStroke();
      fill(farben[i]);
      ellipse(xWerte[i], yWerte[i], sqrt(6*i), sqrt(6*i));
    }
  }
}