////////////////////////////////////////////////////////////////
//Aufgabe 4 aus Kapitel Nebenläufige Programmierung
///////////////////////////////////////////////////////////////
PImage bild;
String description, link;
int messagexLo, messageyLo;//Text Begrenzung links oben
int messagexRu, messageyRu;//Text Begrenzung rechts unten
int titelNummer;
int anzahlSchlangen;
int w,h ; //Dimension geladenes Nasa-Bild
ArrayList<Schlange> schlangen; 

///////////////////////////////////////////////////////////////

void setup() {
  //fullScreen();  
  size(1200, 1200);
  smooth();
  frameRate(40);
  textSize(24);
  colorMode(HSB, 360, 255, 255);

  anzahlSchlangen = 20;
  schlangen = new ArrayList<Schlange>(20);

  messagexLo = 50; //Position des Nasa-Textes
  messageyLo= height-200;
  messagexRu = width -100;
  messageyRu = height - 50;
  description = "";
  titelNummer = 0;
  bild = createImage(width,height,RGB);
}

///////////////////////////////////////////////////////////////

void draw() { 
  background(0); 

  for (int i=0; i<schlangen.size(); i++) {
    Schlange s = schlangen.get(i);
    s.update();
    s.display();
  }

  // wenn genug Schlangen, dann lösche gelegentlich eine...
  if ((random(0, 1)<0.01) && (schlangen.size() == anzahlSchlangen))
    schlangeLoeschen();

  if (frameCount % 20 == 1) thread("schlangeErzeugen");

  if (frameCount % 300 == 1) thread("webzugriff"); //  webzugriff();
  
  //if (frameCount % 300 == 1) webzugriff(); // alternativ: ohne neuen Thread

  fill(360, 0, 160);
  text(description, messagexLo, messageyLo, messagexRu, messageyRu);
  if(w != 0 && h !=0)//warten bis ein Bild geladen ist
  image(bild,width/4,0,width/2,h*width/(2*w)); 
}

//////////////////////////////////////////////////////

void schlangeErzeugen() {
  //  delay((int)random(50,2000));
  if (schlangen.size() < anzahlSchlangen)
    schlangen.add(new Schlange((int) random(width-50), (int) random(height-50), 70));
}

void schlangeLoeschen() {
  if (schlangen.size()>0) 
    schlangen.remove((int)random(0, schlangen.size()-1));
}

//////////////////////////////////////////////////////
// Nachrichtenheader als RSS-Feed esen
//////////////////////////////////////////////////////

void webzugriff() {
  
  String url = "https://www.nasa.gov/rss/dyn/lg_image_of_the_day.rss";
  XML rss = loadXML(url);

  // bearbeite die XML-Daten
  XML[] descriptionXMLElements = rss.getChildren("channel/item/description");
  description  = descriptionXMLElements[0].getContent();//erste Beschreibung für erstes Bild
  XML[] enclosureXML = rss.getChildren("channel/item/enclosure");
  link = enclosureXML[0].getString("url");//URL des ersten Bildes (ist aktuelles Bild des Tages)
 
  bild = loadImage(link);
  w = bild.width;
  h = bild.height; println(w,h);
 
  saveXML(rss, "test.txt");
 
}